import type { DId } from '../../utils/types';
import React from 'react';
export interface DDropdownRef {
    updatePosition: () => void;
}
export interface DDropdownItem<ID extends DId> {
    id: ID;
    label: React.ReactNode;
    type: 'item' | 'group' | 'sub';
    icon?: React.ReactNode;
    disabled?: boolean;
    separator?: boolean;
    children?: DDropdownItem<ID>[];
}
export interface DDropdownProps<ID extends DId, T extends DDropdownItem<ID>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    children: React.ReactElement;
    dList: T[];
    dVisible?: boolean;
    dPlacement?: 'top' | 'top-left' | 'top-right' | 'bottom' | 'bottom-left' | 'bottom-right';
    dTrigger?: 'hover' | 'click';
    dArrow?: boolean;
    dZIndex?: number | string;
    onVisibleChange?: (visible: boolean) => void;
    onItemClick?: (id: T['id'], item: T) => void | boolean | Promise<void>;
    afterVisibleChange?: (visible: boolean) => void;
}
declare function Dropdown<ID extends DId, T extends DDropdownItem<ID>>(props: DDropdownProps<ID, T>, ref: React.ForwardedRef<DDropdownRef>): JSX.Element | null;
export declare const DDropdown: <ID extends DId, T extends DDropdownItem<ID>>(props: DDropdownProps<ID, T> & React.RefAttributes<DDropdownRef>) => ReturnType<typeof Dropdown>;
export {};
