import type { DId } from '../../utils/types';
export type TreeNodeStatus = 'INDETERMINATE' | 'CHECKED' | 'UNCHECKED';
export declare const INDETERMINATE: TreeNodeStatus, CHECKED: TreeNodeStatus, UNCHECKED: TreeNodeStatus;
export interface TreeOrigin {
    disabled?: boolean;
    children?: TreeOrigin[];
}
export declare abstract class AbstractTreeNode<ID extends DId, T extends TreeOrigin> {
    origin: T;
    private _parent;
    constructor(origin: T);
    get parent(): AbstractTreeNode<ID, T> | null;
    get root(): AbstractTreeNode<ID, T>;
    get isLeaf(): boolean;
    get id(): ID;
    get status(): TreeNodeStatus;
    get checked(): boolean;
    get unchecked(): boolean;
    get indeterminate(): boolean;
    get disabled(): boolean;
    get enabled(): boolean;
    updateStatus(checked: ID | null | Set<ID>, onlySelf?: boolean): void;
    protected _setParent(parent: AbstractTreeNode<ID, T>): void;
    protected _updateAncestors(checked: ID | null | Set<ID>, onlySelf: boolean): void;
    abstract children?: AbstractTreeNode<ID, T>[];
    protected abstract _id: ID;
    protected abstract _status: TreeNodeStatus;
    protected abstract _disabled: boolean;
    protected abstract _calculateStatus(checked: ID | null | Set<ID>): void;
}
